function merge(a,b)
	res = {}
	for k,v in pairs(b) do res[k] = v end
	for k,v in pairs(a) do res[#b + k] = v end
	return res
end


keys = {"leg/fr/", "leg/rr/", "leg/rl/", "leg/fl/"}

legs = {"leg/fr/alfa", "leg/fl/alfa", "leg/rr/alfa", "leg/rl/alfa"}

alfas = {"leg/fr/alfa", "leg/fl/alfa", "leg/rr/alfa", "leg/rl/alfa"}
betas = {"leg/fr/beta", "leg/fl/beta", "leg/rr/beta", "leg/rl/beta"}
gamas = {"leg/fr/gama", "leg/fl/gama", "leg/rr/gama", "leg/rl/gama"}

all = merge(alfas, merge(betas,gamas))

dirs = {{1,-1,0}, {1,1,0}, {-1,1,0}, {-1,-1,0}}

goal_angles = {0.785, 3.1415, 3.1415}

set_body_pose{point={0.,0.,0.}, orientation={{1.,0.,0}, 0}}
joint_goto{joints=alfas, pos=goal_angles[1], time=2.}
joint_goto{joints=betas, pos=goal_angles[2], time=2.}
joint_goto{joints=gamas, pos=goal_angles[2], time=2.}
block_yield{joints=all}

tips = {}
for i, leg in pairs(legs) do
	tips[leg] = get_tip_pos{leg=leg, angles=get_leg_state{leg=leg}}
end

n = 2000
f = 128
for i=1,n do
	dir = {0., 1., math.sin(i/f) }
	set_body_pose{point={math.cos(i/f)*0.03,math.sin(i/f)*0.03,0.},orientation={dir, math.cos(i/f)*0.15}}
	for i, leg in pairs(legs) do
		tip_goto{leg=leg, time=0.002, target=tips[leg], steps=64}
	end
	block_yield{joints=all}
end
