#include "node/leg/view.h"
#include "node/robot/model.h"
#include "node/robot/state.h"

#pragma once

namespace schpin
{

class robot_view
{

        std::vector< leg_view > legs_;

      public:
        robot_view( const robot_model& m, const robot_state& s )
        {
                legs_ = map_f_to_v(
                    em::zip( m.get_legs(), s.legs ),
                    em::uncurry | [&]( const leg_model& l, const leg_state& s ) {
                            return leg_view{ l, s };
                    } );
        }

        const std::vector< leg_view >& get_legs() const
        {
                return legs_;
        }
};

}  // namespace schpin
