
#include <random>
#include <schpin_lib/geom/point.h>

#pragma once

namespace schpin
{

template < std::size_t N, typename Tag >
class point_generator
{
        std::mt19937                      gen_{};
        std::normal_distribution< float > normal_d_{0, 1};

      public:
        point< N, Tag > get( vec< 3 > v = vec< 3 >::make_filled_with( 1.f ) )
        {
                point< N, Tag > res{};
                for ( std::size_t i : em::range( N ) ) {
                        res[i] = normal_d_( gen_ ) * v[i];
                }
                return res;
        }
};

}  // namespace schpin
