#ifndef SCHPIN_DISABLE_LOGGING

#include <ros/assert.h>
#include <ros/console.h>

#endif

#pragma once

#ifdef SCHPIN_DISABLE_LOGGING

#define SCHPIN_DEBUG_LOG( name, msg )

#define SCHPIN_DEBUG_LOG_THROTTLE( period, name, msg )

#define SCHPIN_DEBUG_LOG_DELAYED_THROTTLE( period, name, msg )

#define SCHPIN_INFO_LOG( name, msg )

#define SCHPIN_INFO_LOG_THROTTLE( period, name, msg )

#define SCHPIN_INFO_LOG_DELAYED_THROTTLE( period, name, msg )

#define SCHPIN_ERROR_LOG( name, msg ) (void)(sizeof(std::stringstream{} << msg))

#define SCHPIN_ERROR_LOG_THROTTLE( period, name, msg )

#define SCHPIN_ERROR_LOG_DELAYED_THROTTLE( period, name, msg )

#define SCHPIN_WARN_LOG( name, msg )

#define SCHPIN_WARN_LOG_THROTTLE( period, name, msg )

#define SCHPIN_WARN_LOG_DELAYED_THROTTLE( period, name, msg )

#define SCHPIN_ASSERT( cond )

#define SCHPIN_ASSERT_MSG( cond, args )

#endif

#ifndef SCHPIN_DISABLE_LOGGING

#define SCHPIN_DEBUG_LOG( name, msg )                \
        {                                            \
                ROS_DEBUG_STREAM_NAMED( name, msg ); \
        }

#define SCHPIN_DEBUG_LOG_THROTTLE( period, name, msg )                \
        {                                                             \
                ROS_DEBUG_STREAM_THROTTLE_NAMED( period, name, msg ); \
        }

#define SCHPIN_DEBUG_LOG_DELAYED_THROTTLE( period, name, msg )               \
        {                                                                    \
                ROS_DEBUG_STREAM_DELAYED_THROTTLE_NAME( period, name, msg ); \
        }

#define SCHPIN_INFO_LOG( name, msg )                \
        {                                           \
                ROS_INFO_STREAM_NAMED( name, msg ); \
        }

#define SCHPIN_INFO_LOG_THROTTLE( period, name, msg )                \
        {                                                            \
                ROS_INFO_STREAM_THROTTLE_NAMED( period, name, msg ); \
        }

#define SCHPIN_INFO_LOG_DELAYED_THROTTLE( period, name, msg )                \
        {                                                                    \
                ROS_INFO_STREAM_DELAYED_THROTTLE_NAMED( period, name, msg ); \
        }

#define SCHPIN_ERROR_LOG( name, msg )                \
        {                                            \
                ROS_ERROR_STREAM_NAMED( name, msg ); \
        }

#define SCHPIN_ERROR_LOG_THROTTLE( period, name, msg )                \
        {                                                             \
                ROS_ERROR_STREAM_THROTTLE_NAMED( period, name, msg ); \
        }

#define SCHPIN_ERROR_LOG_DELAYED_THROTTLE( period, name, msg )                \
        {                                                                     \
                ROS_ERROR_STREAM_DELAYED_THROTTLE_NAMED( period, name, msg ); \
        }

#define SCHPIN_WARN_LOG( name, msg )                \
        {                                           \
                ROS_WARN_STREAM_NAMED( name, msg ); \
        }

#define SCHPIN_WARN_LOG_THROTTLE( period, name, msg )                \
        {                                                            \
                ROS_WARN_STREAM_THROTTLE_NAMED( period, name, msg ); \
        }

#define SCHPIN_WARN_LOG_DELAYED_THROTTLE( period, name, msg )                \
        {                                                                    \
                ROS_WARN_STREAM_DELAYED_THROTTLE_NAMED( period, name, msg ); \
        }

#define SCHPIN_ASSERT( cond )       \
        {                           \
                ROS_ASSERT( cond ); \
        }

#define SCHPIN_ASSERT_MSG( cond, args )                                                 \
        {                                                                               \
                std::stringstream schpin_assert_stringstream;                           \
                schpin_assert_stringstream << ( args );                                 \
                ROS_ASSERT_MSG( cond, "%s", schpin_assert_stringstream.str().c_str() ); \
        }

#endif
