#include <boost/heap/binomial_heap.hpp>
#include <boost/heap/d_ary_heap.hpp>
#include <boost/heap/fibonacci_heap.hpp>
#include <boost/heap/pairing_heap.hpp>
#include <boost/heap/skew_heap.hpp>

#pragma once

namespace schpin
{
template < typename QueueItem >
using binary_heap = boost::heap::d_ary_heap< QueueItem,
                                             boost::heap::mutable_< true >,
                                             boost::heap::arity< 2 >,
                                             boost::heap::compare< std::greater< QueueItem > > >;

template < typename QueueItem >
using d_ary_heap_4 = boost::heap::d_ary_heap< QueueItem,
                                              boost::heap::mutable_< true >,
                                              boost::heap::arity< 4 >,
                                              boost::heap::compare< std::greater< QueueItem > > >;

template < typename QueueItem >
using d_ary_heap_8 = boost::heap::d_ary_heap< QueueItem,
                                              boost::heap::mutable_< true >,
                                              boost::heap::arity< 8 >,
                                              boost::heap::compare< std::greater< QueueItem > > >;

template < typename QueueItem >
using binom_heap =
    boost::heap::binomial_heap< QueueItem, boost::heap::compare< std::greater< QueueItem > > >;

template < typename QueueItem >
using fibonacci_heap =
    boost::heap::fibonacci_heap< QueueItem, boost::heap::compare< std::greater< QueueItem > > >;

template < typename QueueItem >
using pairing_heap =
    boost::heap::pairing_heap< QueueItem, boost::heap::compare< std::greater< QueueItem > > >;

template < typename QueueItem >
using skew_heap =
    boost::heap::skew_heap< QueueItem, boost::heap::compare< std::greater< QueueItem > > >;

}  // namespace schpin
