#pragma once

namespace schpin
{

class Prompt;

struct Choice
{
        std::string                            key;
        std::function< Prompt( std::string ) > cb;

        Choice( std::string key, std::function< Prompt( std::string ) > cb )
          : key( key )
          , cb( cb )
        {
        }
};

class Prompt
{
        const std::string     msg_;
        std::vector< Choice > choices_;

      public:
        Prompt( std::string msg, std::vector< Choice > choices )
          : msg_( msg )
          , choices_( choices )
        {
        }

        std::optional< Prompt > ask()
        {
        }
};

void runPrompt( Prompt p )
{
        std::optional< Prompt > q = p.ask();
        while ( q ) {
                q = std::move( q->ask() );
        }
}

}  // namespace schpin
