include(CTest)

SET(CMAKE_EXE_LINKER_FLAGS="-fprofile-arcs -ftest-coverage")

add_library(schpin_test_lib STATIC
        test/lib/test_environment.cpp
     )

target_include_directories(schpin_test_lib PUBLIC test/include/ src/)
target_compile_options(schpin_test_lib PRIVATE -O3)

file(GLOB_RECURSE gtest_cpp_files
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*_gtest.cpp")

foreach(gtest_file ${gtest_cpp_files})
	string(REGEX REPLACE ".cpp" "" TEST_NAME ${gtest_file})
	string(REGEX REPLACE "/" "-" TEST_NAME ${TEST_NAME})

	catkin_add_gtest(${TEST_NAME} ${gtest_file} test/unit/main.cpp WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/test/data/)

	target_link_libraries(${TEST_NAME}
                    ${catkin_LIBRARIES}
                    ${Boost_LIBRARIES}
                    ${Boost_SYSTEM_LIBRARY}
                    schpin_test_lib
                    schpin_motion
                    stdc++fs)
	target_include_directories(${TEST_NAME} PRIVATE test/include/)
	target_compile_options(${TEST_NAME} PRIVATE -O0 -g)
endforeach()

